/* A Bison parser, made from ../../src/cfg.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	_LOGFILE	257
# define	_LOGLEVEL	258
# define	_NODELIST	259
# define	_INDEXFILE	260
# define	_NODELISTPATH	261
# define	_ADDRESS	262
# define	_SYSOPNAME	263
# define	_USEOWNZONE	264
# define	_FORCEINTL	265
# define	_LOOPSTR	266
# define	_SCANDIR	267
# define	_MASK	268
# define	_SMASK	269
# define	_PMASK	270
# define	_BODYMASK	271
# define	_SBODYMASK	272
# define	_PBODYMASK	273
# define	_KLUDGEMASK	274
# define	_SKLUDGEMASK	275
# define	_PKLUDGEMASK	276
# define	_ACTION	277
# define	_MAXAGE	278
# define	_BADMESSAGES	279
# define	_NOLOGIGNORE	280
# define	_AKA	281
# define	_SKIPHIDDENFILES	282
# define	_FILEINBOUND	283
# define	_OUTBOUND	284
# define	_ADDTONULLPKT	285
# define	_TEMPMAIL	286
# define	_TRAFFICLOG	287
# define	_PASSWORD	288
# define	_UTC	289
# define	_ORIGIN	290
# define	_TEARLINE	291
# define	_INCLUDE	292
# define	_APKTDIR	293
# define	_CHECKPOINTS	294
# define	_SETVIAALWAYS	295
# define	_FRESH	296
# define	_CREATEMISSINGBASE	297
# define	_USENEWVIA	298
# define	_SCRIPTMASK	299
# define	_SSCRIPTMASK	300
# define	_PSCRIPTMASK	301
# define	_MAXATTACHSIZE	302
# define	_SEMAPHORE	303
# define	_SCRIPTFILE	304
# define	_USEASO	305
# define	_FILEBOXDIR	306
# define	_KILLROUTEDMESSAGE	307
# define	_IGNOREBSY	308
# define	_AFTERSCRIPT	309
# define	_BEFORESCRIPT	310
# define	_AGEFROMVIA	311
# define	_MAXNODELISTAGE	312
# define	_USEFILEBOXES	313
# define	_FILEBOXTYPE	314
# define	_LONG	315
# define	_TMLONG	316
# define	_TMSHORT	317
# define	_SOFTCHECKINNODELIST	318
# define	_BADPACKETS	319
# define	_IGNOREATTACHPATH	320
# define	_TIMESTAMPFILE	321
# define	_TRAFFICLOGTEMPLATE	322
# define	_STRIPPATHINPKT	323
# define	_CRLF	324
# define	_SKIP	325
# define	_DELETE	326
# define	_EXIT	327
# define	_MOVE	328
# define	__EOF	329
# define	_STRING	330
# define	_BEFOREROUTE	331
# define	_AFTERROUTE	332
# define	_DIGIT_	333
# define	_RENUMBER	334
# define	_UNPACK	335
# define	_DAILY	336
# define	_WEEKLY	337
# define	_FLAG	338
# define	_NEVER	339
# define	_HARD	340
# define	_SOFT	341
# define	_ALWAYS	342
# define	_ADDNOTE	343
# define	_COPY	344
# define	_REWRITE	345
# define	_IGNORE	346
# define	_DISPLAY	347
# define	_DELFILE	348
# define	_NEWMSG	349
# define	_WRITEFILE	350
# define	_APPENDTOFILE	351
# define	_CALL	352
# define	_ROUTE	353
# define	_ROUTEFBOX	354
# define	_ROUTEHUB	355
# define	_POLL	356
# define	_DELETEATTACH	357
# define	_CHANGEPATH	358
# define	_MOVEATTACH	359
# define	_ASCRIPT	360
# define	_TOLOWERPATH	361
# define	_TOUPPERPATH	362
# define	_COPYATTACHFBOX	363
# define	_MOVEATTACHFBOX	364
# define	_COPYATTACH	365
# define	_SPLIT	366
# define	_RECODE	367
# define	_HOLD	368
# define	_CRASH	369
# define	_DIRECT	370
# define	_NORMAL	371
# define	LEXERR	372



#if (defined(__WATCOMC__) && defined(__386__)) || defined(__DJGPP__) || defined(__MINGW32__)
#define HAS_strupr 1
#endif
#define YYDEBUG 0
/* #define YYERROR_VERBOSE */
#ifdef __MINGW32__
#ifndef _STAT_DEFINED
#define _STAT_DEFINED 1
#endif
#endif

#include <stdlib.h>
#ifdef __WATCOMC__
   #include <malloc.h>
#endif
#include "msg.hpp"
#include "outbound.hpp"
#include "fidoaddr.h"
#include "vars.hpp"
#include "configure.hpp"
#include "constant.hpp"
#include "log.hpp"
#include "aka.hpp"
#include "age.hpp"
#include "scandir.hpp"
#include "attach.hpp"
#include "badpkt.hpp"
#include "badmsg.hpp"
#include "passwd.hpp"
#include "nodelist.hpp"
#include "script.hpp"

#undef YYSTYPE               /* Perl also use bison? damn! */

extern int DetectError;
extern int NoTokensF;

extern FA   cffa;
extern FA   cffa1;
extern FA   cffa2;

static int brf = FALSE, arf = FALSE, renumberf = FALSE, unpackf = FALSE, freshf = FALSE;
static ScanDir *wsd = NULL;
static char *FileName = NULL;
static char *BPktDir = NULL;
static char *ScriptBefore = NULL;
static char *ScriptAfter = NULL;
static tTimes *tt;
static IndBiList<tTimes> *_TTimes;
static MSGBASE *mbase;
static Mask *msk = NULL;
static int MaskMode;
static int rc;
static int FlagMode = 0;
static Action *act = NULL;

static void CheckETTime(void) {
time_t tmt;
   if (tt->_ETime != 0 && tt->_ETime < tt->_STime) {
      tmt = tt->_ETime;
      tt->_ETime = (23*60*60)+(59*60)+59;
      tt->_ETime += TimeOfBeginOfDay(-1);
      _TTimes->AddToEnd(tt);
      tt = new tTimes;
      tt->_STime = TimeOfBeginOfDay(-1);
      tt->_ETime = tmt;
   }
}

static int PrepareMask(Mask &m) {
ScanDir *sd;
char ErrMess[128];

   CHP = 23700;
   sd = ScanDirs.GetLast();
   if (sd == NULL) {
      strcpy(ErrMess,"'");
      strcat(ErrMess,m.MaskName());
      strcat(ErrMess,":' without 'ScanDir:'");
      yyerror(ErrMess);
      return -1;
   }
   m.sd = sd;
   return 0;
}

static void AddReadyMask(Mask &m) {
ScanDir *sd;

   switch (PrevMask) {
      case 0: // first mask.
      case 1: // after action.
         LastDo = new DoList();
         sd = ScanDirs.GetLast();
         sd->_DoLists.AddToEnd(LastDo);
         PrevMask = 2;
         break;
      case 2: // after MASK.
         break;
   }
   LastDo->AddMask(m);
}


static int CheckMaskMode(char *f) {
char Buff[128];
   if (MaskMode != 0) {
      strcpy(Buff,"You can use '");
      strcat(Buff,f);
      strcat(Buff,"' flag only in 'Mask:'.");
      yyerror(Buff);
      return -1;
   }
   return 0;
}


static int ctoi(char *s) {
   char *foo;
   int res = 0;

   res = strtoul(s, &foo, 0);
   if (*foo)	/* parse error */
      return 0;
   return res;
}




#ifndef YYSTYPE
typedef union {
   int          in;
   char         *ch;
   long         ln;
   KillModeT    kmode;
   CheckPointsT pmode;
   tBadMsgMode  bmode;
   tBadMsgMode  bpmode;   
   fileboxType	fbtype;
   time_t       t;
   PKTMode      pktmode;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		506
#define	YYFLAG		-32768
#define	YYNTBASE	165

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 372 ? yytranslate[x] : 314)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const short yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   128,     2,   158,   125,   127,   163,     2,
       2,     2,   126,   119,     2,   120,   121,   164,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   124,     2,
       2,     2,     2,     2,   162,   130,     2,     2,   161,   135,
       2,     2,   159,     2,     2,     2,   143,     2,     2,     2,
     123,     2,     2,   150,     2,   160,     2,     2,     2,     2,
       2,   156,     2,   157,     2,     2,     2,   129,   131,   132,
     133,   134,   136,   137,   138,   139,   140,   141,   142,   144,
     145,   146,   122,   147,   148,   149,   151,   152,   153,     2,
     154,   155,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     7,    10,    13,    16,    19,    22,
      25,    28,    31,    34,    37,    40,    43,    46,    49,    52,
      55,    58,    61,    64,    67,    70,    73,    76,    79,    82,
      85,    88,    91,    94,    97,   100,   103,   106,   109,   112,
     115,   118,   121,   124,   127,   130,   133,   136,   139,   142,
     145,   148,   151,   154,   157,   160,   163,   166,   169,   172,
     175,   178,   181,   184,   187,   188,   192,   194,   197,   200,
     203,   205,   207,   209,   212,   216,   219,   220,   221,   227,
     230,   233,   234,   238,   241,   243,   245,   247,   250,   252,
     254,   256,   259,   262,   265,   268,   271,   275,   276,   278,
     281,   284,   287,   290,   293,   296,   299,   302,   305,   308,
     309,   314,   317,   319,   321,   323,   326,   329,   331,   333,
     335,   338,   341,   343,   346,   349,   350,   354,   357,   358,
     363,   365,   367,   368,   371,   373,   376,   379,   381,   383,
     385,   386,   390,   391,   395,   396,   399,   401,   405,   409,
     411,   413,   414,   419,   420,   423,   425,   429,   430,   432,
     433,   437,   438,   442,   443,   447,   448,   449,   450,   451,
     452,   453,   466,   468,   470,   472,   474,   476,   478,   481,
     483,   484,   486,   488,   489,   492,   494,   497,   499,   500,
     504,   505,   509,   511,   513,   515,   517,   519,   521,   523,
     525,   527,   529,   531,   533,   535,   537,   539,   541,   543,
     545,   547,   549,   551,   553,   555,   557,   559,   561,   563,
     565,   567,   570,   573,   576,   577,   582,   585,   588,   591,
     592,   597,   600,   603,   606,   607,   610,   611,   612,   618,
     619,   623,   625,   627,   629,   631,   633,   635,   637,   639,
     641,   643,   645,   647,   649,   651,   653,   655,   657,   659,
     661,   663,   665,   667,   669,   671,   673,   675,   677,   679,
     682,   685,   688,   689,   693,   696,   699,   701,   704,   707,
     708,   714,   718,   722,   727,   730,   731,   736,   737,   742,
     743,   747,   748,   753,   754,   759,   761,   763,   765,   767,
     768,   773,   776,   778,   780,   783,   786,   789,   792,   794,
     797,   799,   801,   803,   805,   807,   809,   811,   813,   815,
     817,   819,   823,   827,   829,   831,   837,   839
};
static const short yyrhs[] =
{
      -1,   165,   166,     0,   268,    70,     0,   174,    70,     0,
     178,    70,     0,   180,    70,     0,    31,    70,     0,   175,
      70,     0,   179,    70,     0,   258,    70,     0,   259,    70,
       0,   260,    70,     0,   182,    70,     0,    43,    70,     0,
     201,    70,     0,    11,    70,     0,   190,    70,     0,   194,
      70,     0,   184,    70,     0,   253,    70,     0,   254,    70,
       0,   255,    70,     0,   188,    70,     0,   189,    70,     0,
     195,    70,     0,   229,    70,     0,   231,    70,     0,   233,
      70,     0,   202,    70,     0,   196,    70,     0,   197,    70,
       0,   191,    70,     0,   193,    70,     0,    26,    70,     0,
     198,    70,     0,   203,    70,     0,   263,    70,     0,   264,
      70,     0,   265,    70,     0,    54,    70,     0,    66,    70,
       0,    41,    70,     0,    28,    70,     0,    64,    70,     0,
     186,    70,     0,   187,    70,     0,    44,    70,     0,    10,
      70,     0,    51,    70,     0,    59,    70,     0,    69,    70,
       0,    57,    70,     0,   209,    70,     0,   199,    70,     0,
     200,    70,     0,   205,    70,     0,   207,    70,     0,   211,
      70,     0,   173,    70,     0,   172,    70,     0,   168,    70,
       0,   169,    70,     0,   170,    70,     0,     0,     1,    70,
     167,     0,    70,     0,    50,    76,     0,    52,    76,     0,
      60,   171,     0,    61,     0,    62,     0,    63,     0,    68,
      76,     0,    49,    79,    76,     0,    38,    76,     0,     0,
       0,    27,   176,   308,   177,   308,     0,    67,    76,     0,
      39,    76,     0,     0,     8,   181,   308,     0,    40,   183,
       0,    85,     0,    86,     0,    87,     0,    53,   185,     0,
      88,     0,    85,     0,    84,     0,     9,    76,     0,    37,
      76,     0,     3,    76,     0,     4,    79,     0,    36,    76,
       0,     5,    76,   192,     0,     0,    79,     0,     7,    76,
       0,     6,    76,     0,    12,    76,     0,    48,    79,     0,
      58,    79,     0,    30,    76,     0,    32,    76,     0,    33,
      76,     0,    29,    76,     0,    24,    79,     0,     0,    34,
      76,   204,   308,     0,    25,   206,     0,    71,     0,    73,
       0,    72,     0,    74,    76,     0,    65,   208,     0,    71,
       0,    73,     0,    72,     0,    74,    76,     0,    35,   210,
       0,    79,     0,   119,    79,     0,   120,    79,     0,     0,
      13,   212,   213,     0,   215,   228,     0,     0,    76,   214,
     216,   228,     0,    77,     0,    78,     0,     0,   216,   217,
       0,    80,     0,    56,    76,     0,    55,    76,     0,    42,
       0,    81,     0,   218,     0,     0,    82,   219,   221,     0,
       0,    83,   220,   226,     0,     0,   221,   222,     0,   224,
       0,   224,   120,   224,     0,   223,   121,   224,     0,   122,
       0,   123,     0,     0,    79,   225,   124,    79,     0,     0,
     226,   227,     0,    79,     0,    79,   120,    79,     0,     0,
     281,     0,     0,    14,   230,   235,     0,     0,    15,   232,
     235,     0,     0,    16,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   242,   237,   308,   238,   242,   239,
     308,   240,   243,   241,   246,     0,    76,     0,   125,     0,
     126,     0,   127,     0,    76,     0,   126,     0,   245,    79,
       0,   126,     0,     0,   128,     0,   126,     0,     0,   247,
     248,     0,   249,     0,   248,   249,     0,   252,     0,     0,
     119,   250,   252,     0,     0,   120,   251,   252,     0,   129,
       0,   130,     0,   131,     0,   132,     0,   133,     0,   134,
       0,   135,     0,   136,     0,   137,     0,   138,     0,   139,
       0,   140,     0,   141,     0,   142,     0,   143,     0,   144,
       0,   145,     0,   146,     0,   122,     0,   147,     0,   148,
       0,   149,     0,   150,     0,   151,     0,   152,     0,   153,
       0,   154,     0,   155,     0,    79,     0,    20,   256,     0,
      21,   256,     0,    22,   256,     0,     0,   257,   243,   243,
     244,     0,    17,   261,     0,    18,   261,     0,    19,   261,
       0,     0,   262,   243,   244,   244,     0,    45,   266,     0,
      46,   266,     0,    47,   266,     0,     0,   267,    76,     0,
       0,     0,    23,   269,   272,   270,   271,     0,     0,   156,
     218,   157,     0,   273,     0,    72,     0,   274,     0,   275,
       0,   276,     0,    92,     0,   278,     0,   280,     0,   282,
       0,   283,     0,   285,     0,   286,     0,   287,     0,   288,
       0,   290,     0,   292,     0,   299,     0,   103,     0,   301,
       0,   302,     0,   303,     0,   304,     0,   296,     0,   305,
       0,   294,     0,   306,     0,   307,     0,   279,     0,    89,
      76,     0,    74,    76,     0,    90,    76,     0,     0,    91,
     277,   235,     0,    93,    76,     0,   106,    76,     0,   281,
       0,    84,    76,     0,    94,    76,     0,     0,    95,   284,
      76,    76,   235,     0,    96,    76,    76,     0,    97,    76,
      76,     0,    98,    76,    76,    76,     0,    98,    76,     0,
       0,    99,   298,   289,   308,     0,     0,   100,   298,   291,
     308,     0,     0,   101,   298,   293,     0,     0,   109,   298,
     295,   308,     0,     0,   110,   298,   297,   308,     0,   114,
       0,   115,     0,   116,     0,   117,     0,     0,   102,   298,
     300,   308,     0,   104,    76,     0,   107,     0,   108,     0,
     105,    76,     0,   111,    76,     0,   112,    79,     0,   113,
      76,     0,   309,     0,   128,   309,     0,   312,     0,   310,
       0,   126,     0,   158,     0,   159,     0,   160,     0,   161,
       0,   123,     0,   162,     0,   125,     0,   127,     0,   127,
     121,    79,     0,   312,   121,   311,     0,   313,     0,   163,
       0,   313,   124,   313,   164,   313,     0,    79,     0,   126,
       0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   183,   184,   188,   189,   194,   195,   196,   202,   203,
     204,   205,   206,   207,   208,   214,   215,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   244,   245,   246,   247,   248,
     249,   255,   261,   267,   273,   279,   280,   281,   287,   293,
     299,   305,   311,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   328,   331,   337,   344,   351,
     358,   359,   360,   364,   371,   379,   382,   382,   382,   392,
     400,   408,   408,   417,   420,   421,   422,   425,   428,   429,
     430,   433,   441,   449,   457,   465,   473,   481,   482,   485,
     493,   501,   509,   517,   525,   533,   541,   549,   557,   566,
     566,   583,   591,   592,   593,   594,   597,   605,   606,   607,
     608,   611,   619,   620,   621,   626,   626,   657,   658,   658,
     678,   679,   682,   683,   686,   695,   703,   711,   720,   733,
     743,   743,   756,   756,   771,   772,   782,   786,   791,   812,
     813,   816,   816,   838,   839,   847,   856,   868,   869,   874,
     874,   880,   880,   886,   886,   892,   892,   892,   892,   892,
     892,   892,   949,   950,   951,   952,   955,   956,   959,   966,
     969,   970,   973,   974,   974,   976,   977,   980,   981,   981,
     982,   982,   985,   986,   996,   997,   998,   999,  1005,  1011,
    1012,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1045,
    1046,  1061,  1067,  1073,  1079,  1079,  1096,  1102,  1108,  1114,
    1114,  1132,  1138,  1144,  1150,  1150,  1169,  1169,  1169,  1188,
    1189,  1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,  1203,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,  1212,  1213,  1214,  1215,  1216,  1217,  1218,  1219,  1222,
    1235,  1256,  1277,  1277,  1286,  1292,  1302,  1308,  1311,  1317,
    1317,  1358,  1372,  1386,  1399,  1405,  1405,  1423,  1423,  1446,
    1446,  1457,  1457,  1469,  1469,  1481,  1482,  1483,  1484,  1487,
    1487,  1501,  1511,  1517,  1522,  1535,  1548,  1558,  1610,  1611,
    1614,  1615,  1616,  1623,  1630,  1637,  1644,  1651,  1658,  1665,
    1672,  1679,  1692,  1695,  1696,  1699,  1708,  1709
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "_LOGFILE", "_LOGLEVEL", "_NODELIST", 
  "_INDEXFILE", "_NODELISTPATH", "_ADDRESS", "_SYSOPNAME", "_USEOWNZONE", 
  "_FORCEINTL", "_LOOPSTR", "_SCANDIR", "_MASK", "_SMASK", "_PMASK", 
  "_BODYMASK", "_SBODYMASK", "_PBODYMASK", "_KLUDGEMASK", "_SKLUDGEMASK", 
  "_PKLUDGEMASK", "_ACTION", "_MAXAGE", "_BADMESSAGES", "_NOLOGIGNORE", 
  "_AKA", "_SKIPHIDDENFILES", "_FILEINBOUND", "_OUTBOUND", 
  "_ADDTONULLPKT", "_TEMPMAIL", "_TRAFFICLOG", "_PASSWORD", "_UTC", 
  "_ORIGIN", "_TEARLINE", "_INCLUDE", "_APKTDIR", "_CHECKPOINTS", 
  "_SETVIAALWAYS", "_FRESH", "_CREATEMISSINGBASE", "_USENEWVIA", 
  "_SCRIPTMASK", "_SSCRIPTMASK", "_PSCRIPTMASK", "_MAXATTACHSIZE", 
  "_SEMAPHORE", "_SCRIPTFILE", "_USEASO", "_FILEBOXDIR", 
  "_KILLROUTEDMESSAGE", "_IGNOREBSY", "_AFTERSCRIPT", "_BEFORESCRIPT", 
  "_AGEFROMVIA", "_MAXNODELISTAGE", "_USEFILEBOXES", "_FILEBOXTYPE", 
  "_LONG", "_TMLONG", "_TMSHORT", "_SOFTCHECKINNODELIST", "_BADPACKETS", 
  "_IGNOREATTACHPATH", "_TIMESTAMPFILE", "_TRAFFICLOGTEMPLATE", 
  "_STRIPPATHINPKT", "_CRLF", "_SKIP", "_DELETE", "_EXIT", "_MOVE", 
  "__EOF", "_STRING", "_BEFOREROUTE", "_AFTERROUTE", "_DIGIT_", 
  "_RENUMBER", "_UNPACK", "_DAILY", "_WEEKLY", "_FLAG", "_NEVER", "_HARD", 
  "_SOFT", "_ALWAYS", "_ADDNOTE", "_COPY", "_REWRITE", "_IGNORE", 
  "_DISPLAY", "_DELFILE", "_NEWMSG", "_WRITEFILE", "_APPENDTOFILE", 
  "_CALL", "_ROUTE", "_ROUTEFBOX", "_ROUTEHUB", "_POLL", "_DELETEATTACH", 
  "_CHANGEPATH", "_MOVEATTACH", "_ASCRIPT", "_TOLOWERPATH", 
  "_TOUPPERPATH", "_COPYATTACHFBOX", "_MOVEATTACHFBOX", "_COPYATTACH", 
  "_SPLIT", "_RECODE", "_HOLD", "_CRASH", "_DIRECT", "_NORMAL", "LEXERR", 
  "'+'", "'-'", "'.'", "'p'", "'P'", "':'", "'$'", "'*'", "'%'", "'!'", 
  "'a'", "'A'", "'b'", "'c'", "'d'", "'e'", "'E'", "'f'", "'g'", "'h'", 
  "'i'", "'j'", "'k'", "'l'", "'L'", "'m'", "'n'", "'o'", "'q'", "'r'", 
  "'s'", "'S'", "'t'", "'u'", "'v'", "'x'", "'y'", "'['", "']'", "'#'", 
  "'H'", "'U'", "'D'", "'@'", "'&'", "'/'", "Conf", "ConfLine", "@1", 
  "ScriptFile", "FileBoxDir", "FileBoxType", "FBOXTYPE", 
  "TrafficLogTemplate", "Semaphore", "IncludeF", "Aka", "@2", "@3", 
  "TimeStampFile", "APktDir", "Address", "@4", "CheckPoints", 
  "ChkPntMode", "KillRoutedMessage", "KillRMode", "SysopName", "TearLine", 
  "LogFile", "LogLevel", "Origin", "Nodelist", "NdlZone", "NodelistPath", 
  "IndexFile", "LoopStr", "MaxAttachSize", "MaxNodelistAge", "Outbound", 
  "TempMail", "TrafficLog", "FileInbound", "MaxAge", "Password", "@5", 
  "BadMessages", "BadMsgMode", "BadPackets", "BadPktMode", "Utc", 
  "UtcOffs", "ScanDir", "@6", "SDType", "@7", "BeforeAfter", "AddSdParam", 
  "SdParam", "STime", "@8", "@9", "DaySTime", "DaySSTime", "AnyP", "Time", 
  "@10", "WeekSTime", "WeekSSTime", "Flag", "Mask", "@11", "SMask", "@12", 
  "PMask", "@13", "MParam", "@14", "@15", "@16", "@17", "@18", "@19", 
  "SyName", "MString", "MDigit", "MNot", "MsgAttr", "@20", "MsgFAttr", 
  "FlagsMode", "@21", "@22", "FlagsChar", "KludgeMask", "SKludgeMask", 
  "PKludgeMask", "KMParam", "@23", "BodyMask", "SBodyMask", "PBodyMask", 
  "BMParam", "@24", "ScriptMask", "SScriptMask", "PScriptMask", 
  "SCRMParam", "@25", "Action", "@26", "@27", "MayBeActTime", "ActionCmd", 
  "AAddNote", "AMove", "ACopy", "ARewrite", "@28", "ADisplay", "AScript", 
  "AAFlag", "AFlag", "ADelFile", "ANewMsg", "@29", "AWriteFile", 
  "AAppendToFile", "ACall", "ARoute", "@30", "ARouteFbox", "@31", 
  "ARouteHub", "@32", "ACopyAttachFbox", "@33", "AMoveAttachFbox", "@34", 
  "RouMode", "APoll", "@35", "AChangePath", "AToLowerPath", 
  "AToUpperPath", "AMoveAttach", "ACopyAttach", "ASplit", "ARecode", 
  "faddress", "FullFtnAddr", "pointaddr", "PntAddr", "nodeaddr", "dw", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,   165,   165,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   167,   166,   166,   168,   169,   170,
     171,   171,   171,   172,   173,   174,   176,   177,   175,   178,
     179,   181,   180,   182,   183,   183,   183,   184,   185,   185,
     185,   186,   187,   188,   189,   190,   191,   192,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   204,
     203,   205,   206,   206,   206,   206,   207,   208,   208,   208,
     208,   209,   210,   210,   210,   212,   211,   213,   214,   213,
     215,   215,   216,   216,   217,   217,   217,   217,   217,   217,
     219,   218,   220,   218,   221,   221,   222,   222,   222,   223,
     223,   225,   224,   226,   226,   227,   227,   228,   228,   230,
     229,   232,   231,   234,   233,   236,   237,   238,   239,   240,
     241,   235,   242,   242,   242,   242,   243,   243,   244,   244,
     245,   245,   246,   247,   246,   248,   248,   249,   250,   249,
     251,   249,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   253,   254,   255,   257,   256,   258,   259,   260,   262,
     261,   263,   264,   265,   267,   266,   269,   270,   268,   271,
     271,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   273,
     274,   275,   277,   276,   278,   279,   280,   281,   282,   284,
     283,   285,   286,   287,   287,   289,   288,   291,   290,   293,
     292,   295,   294,   297,   296,   298,   298,   298,   298,   300,
     299,   301,   302,   303,   304,   305,   306,   307,   308,   308,
     309,   309,   309,   309,   309,   309,   309,   309,   309,   309,
     309,   309,   310,   311,   311,   312,   313,   313
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     0,     3,     1,     2,     2,     2,
       1,     1,     1,     2,     3,     2,     0,     0,     5,     2,
       2,     0,     3,     2,     1,     1,     1,     2,     1,     1,
       1,     2,     2,     2,     2,     2,     3,     0,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     0,
       4,     2,     1,     1,     1,     2,     2,     1,     1,     1,
       2,     2,     1,     2,     2,     0,     3,     2,     0,     4,
       1,     1,     0,     2,     1,     2,     2,     1,     1,     1,
       0,     3,     0,     3,     0,     2,     1,     3,     3,     1,
       1,     0,     4,     0,     2,     1,     3,     0,     1,     0,
       3,     0,     3,     0,     3,     0,     0,     0,     0,     0,
       0,    12,     1,     1,     1,     1,     1,     1,     2,     1,
       0,     1,     1,     0,     2,     1,     2,     1,     0,     3,
       0,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     0,     4,     2,     2,     2,     0,
       4,     2,     2,     2,     0,     2,     0,     0,     5,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     0,     3,     2,     2,     1,     2,     2,     0,
       5,     3,     3,     4,     2,     0,     4,     0,     4,     0,
       3,     0,     4,     0,     4,     1,     1,     1,     1,     0,
       4,     2,     1,     1,     2,     2,     2,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     1,     5,     1,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,     0,     0,     0,     0,     0,     0,     0,    81,     0,
       0,     0,     0,   125,   159,   161,   163,   229,   229,   229,
     224,   224,   224,   236,     0,     0,     0,    76,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   234,   234,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    66,     2,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    64,    93,    94,    97,   100,    99,     0,    91,
      48,    16,   101,     0,   165,   165,   165,   226,     0,   227,
     228,   221,     0,   222,   223,     0,   108,   112,   114,   113,
       0,   111,    34,     0,    43,   107,   104,     7,   105,   106,
     109,   122,     0,     0,   121,    95,    92,    75,    80,    84,
      85,    86,    83,    42,    14,    47,   231,     0,   232,   233,
     102,     0,    67,    49,    68,    90,    89,    88,    87,    40,
      52,   103,    50,    70,    71,    72,    69,    44,   117,   119,
     118,     0,   116,    41,    79,    73,    51,    61,    62,    63,
      60,    59,     4,     8,     5,     9,     6,    13,    19,    45,
      46,    23,    24,    17,    32,    33,    18,    25,    30,    31,
      35,    54,    55,    15,    29,    36,    56,    57,    53,    58,
      26,    27,    28,    20,    21,    22,    10,    11,    12,    37,
      38,    39,     3,    65,    98,    96,   326,   317,   319,   312,
     320,     0,   313,   314,   315,   316,   318,    82,   308,   311,
     310,     0,   128,   130,   131,   126,   157,   160,     0,   162,
     164,   176,   177,   180,     0,   242,     0,     0,     0,     0,
     272,   246,     0,     0,   279,     0,     0,     0,     0,     0,
       0,     0,   258,     0,     0,     0,   302,   303,     0,     0,
       0,     0,     0,   237,   241,   243,   244,   245,   247,   268,
     248,   276,   249,   250,   251,   252,   253,   254,   255,   256,
     265,   263,   257,   259,   260,   261,   262,   264,   266,   267,
     115,    77,     0,   123,   124,   235,    74,   120,     0,   309,
       0,     0,   132,   127,   158,   172,   173,   174,   175,   166,
     179,   181,   180,     0,   180,   270,   277,   269,   271,   165,
     274,   278,     0,     0,     0,   284,   295,   296,   297,   298,
     285,   287,   289,   299,   301,   304,   275,   291,   293,   305,
     306,   307,   239,     0,   110,   321,   327,   324,   322,   323,
       0,   157,     0,   230,   178,   225,   273,     0,   281,   282,
       0,     0,     0,   290,     0,     0,     0,     0,   238,    78,
       0,   137,     0,     0,   134,   138,   140,   142,   133,   139,
     129,   167,   165,   283,   286,   288,   300,   292,   294,     0,
     325,   136,   135,   144,   153,     0,   280,   240,   141,   143,
     168,   151,   149,   150,   145,     0,   146,   155,   154,     0,
       0,     0,     0,     0,   169,     0,   148,   147,   156,     0,
     152,   170,   183,   182,   171,     0,   220,   188,   190,   210,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   184,   185,   187,
       0,     0,   186,   189,   191,     0,     0
};

static const short yydefgoto[] =
{
       1,    65,   243,    66,    67,    68,   186,    69,    70,    71,
      72,   143,   383,    73,    74,    75,   118,    76,   162,    77,
     178,    78,    79,    80,    81,    82,    83,   245,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,   332,
      95,   141,    96,   192,    97,   154,    98,   123,   265,   342,
     266,   391,   418,   419,   433,   434,   438,   444,   445,   446,
     450,   439,   448,   343,    99,   124,   100,   125,   101,   126,
     267,   268,   392,   435,   449,   459,   462,   349,   273,   352,
     353,   464,   465,   497,   498,   500,   501,   499,   102,   103,
     104,   131,   132,   105,   106,   107,   127,   128,   108,   109,
     110,   166,   167,   111,   135,   382,   408,   303,   304,   305,
     306,   307,   359,   308,   309,   310,   344,   312,   313,   362,
     314,   315,   316,   317,   401,   318,   402,   319,   403,   320,
     405,   321,   406,   370,   322,   404,   323,   324,   325,   326,
     327,   328,   329,   257,   258,   259,   388,   260,   261
};

static const short yypact[] =
{
  -32768,   325,   -45,   -48,   -29,   -32,    -2,    11,-32768,    18,
      33,    68,    63,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,    61,   -60,    71,-32768,    74,    69,
      70,    77,    72,    73,   102,   -50,   104,   106,   107,   108,
     -44,   111,   115,   116,-32768,-32768,-32768,   109,   112,   117,
     122,   143,   -58,   150,   151,   144,   152,    10,   154,   -38,
     155,   153,   156,   157,-32768,-32768,   158,   160,   161,   163,
     164,   165,   167,   168,   169,   170,   172,   173,   174,   175,
     176,   177,   178,   179,   181,   182,   183,   184,   185,   186,
     187,   188,   191,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,-32768,-32768,-32768,   147,-32768,-32768,   -69,-32768,
  -32768,-32768,-32768,     0,-32768,-32768,-32768,-32768,   -61,-32768,
  -32768,-32768,   -61,-32768,-32768,   105,-32768,-32768,-32768,-32768,
     214,-32768,-32768,   -69,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   215,   216,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,   217,-32768,-32768,
  -32768,   220,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   221,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   162,
      66,   -63,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
     166,   180,-32768,-32768,-32768,-32768,   218,-32768,   -59,-32768,
  -32768,-32768,-32768,   -47,   -61,-32768,   222,   224,   225,   227,
  -32768,-32768,   229,   230,-32768,   232,   233,   234,   -77,   -77,
     -77,   -77,-32768,   235,   236,   237,-32768,-32768,   -77,   -77,
     238,   239,   240,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   -69,-32768,-32768,-32768,-32768,-32768,   241,-32768,
     -75,   -71,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   -47,   242,   -47,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   243,   246,   247,   248,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   128,   -69,-32768,-32768,-32768,-32768,-32768,-32768,
     121,   -35,   -69,-32768,-32768,-32768,-32768,   291,-32768,-32768,
     304,   -69,   -69,-32768,   -69,   -69,   -69,   -64,-32768,-32768,
     -71,-32768,   305,   310,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   131,
  -32768,-32768,-32768,-32768,-32768,   -59,-32768,-32768,   -70,   308,
  -32768,-32768,-32768,-32768,-32768,   171,   268,   276,-32768,   -69,
     193,   318,   318,   319,-32768,   320,-32768,-32768,-32768,   -61,
  -32768,-32768,   189,-32768,-32768,   -18,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,   -18,-32768,-32768,
      21,    21,-32768,-32768,-32768,   289,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,  -116,-32768,-32768,-32768,-32768,-32768,  -368,
  -32768,-32768,-32768,     9,-32768,-32768,-32768,-32768,-32768,-32768,
    -123,-32768,-32768,-32768,-32768,-32768,-32768,   -34,  -132,  -272,
  -32768,-32768,-32768,-32768,   -95,-32768,-32768,  -415,-32768,-32768,
  -32768,    84,-32768,-32768,-32768,-32768,    89,-32768,-32768,-32768,
  -32768,    64,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   269,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,  -267,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,  -142,   159,-32768,-32768,-32768,  -335
};


#define	YYLAST		410


static const short yytable[] =
{
     274,   331,   269,   270,   246,   389,   390,   411,   246,   441,
     246,   137,   138,   139,   140,   271,   246,   345,   416,   417,
     412,   413,   371,   372,   373,   112,   175,   176,   113,   151,
     177,   377,   378,   188,   189,   190,   191,   366,   367,   368,
     369,   159,   160,   161,   115,   414,   415,   416,   417,   277,
     114,   386,   442,   443,   247,   386,   248,   249,   250,   251,
     247,   466,   248,   249,   250,   272,   346,   347,   348,   152,
     153,   183,   184,   185,   116,   430,   262,   263,   264,   350,
     393,   351,   395,   456,   457,   503,   504,   117,   387,   252,
     253,   254,   255,   256,   119,   252,   253,   254,   255,   256,
     466,   467,   468,   120,   469,   133,   134,   129,   130,   168,
     169,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   121,   122,
     136,   142,   354,   469,   144,   145,   146,   147,   148,   149,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   275,   150,   276,
     155,   163,   156,   157,   158,   164,   165,   338,   170,   277,
     384,   171,   173,   172,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   174,
     179,   180,   182,   181,   187,   193,   244,   196,   197,   194,
     198,   199,   195,   200,   201,   202,   396,   203,   204,   205,
     206,   409,   207,   208,   209,   210,   211,   212,   213,   214,
     421,   215,   216,   217,   218,   219,   220,   221,   222,   424,
     425,   223,   426,   427,   428,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   407,   410,  -327,   340,   437,   506,
     330,   429,   451,   335,   333,   334,   336,   337,   355,   436,
     356,   357,   277,   358,   341,   360,   361,   454,   363,   364,
     365,   374,   375,   376,   379,   463,   381,   455,   380,   397,
     385,   394,   398,   399,   400,   505,     2,   461,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,   422,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
     423,   431,    54,    55,    56,    57,   432,   447,   452,    58,
      59,    60,    61,    62,    63,    64,   453,   441,   458,   460,
     420,   440,   502,     0,   311,     0,     0,     0,     0,     0,
     339
};

static const short yycheck[] =
{
     132,   143,   125,   126,    79,   340,   341,    42,    79,    79,
      79,    71,    72,    73,    74,    76,    79,    76,    82,    83,
      55,    56,   289,   290,   291,    70,    84,    85,    76,    79,
      88,   298,   299,    71,    72,    73,    74,   114,   115,   116,
     117,    85,    86,    87,    76,    80,    81,    82,    83,    84,
      79,   126,   122,   123,   123,   126,   125,   126,   127,   128,
     123,    79,   125,   126,   127,   126,   125,   126,   127,   119,
     120,    61,    62,    63,    76,   410,    76,    77,    78,   126,
     352,   128,   354,   451,   452,   500,   501,    76,   163,   158,
     159,   160,   161,   162,    76,   158,   159,   160,   161,   162,
      79,   119,   120,    70,   122,    21,    22,    18,    19,    45,
      46,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    70,    76,
      79,    70,   274,   122,    70,    76,    76,    70,    76,    76,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    72,    76,    74,
      76,    70,    76,    76,    76,    70,    70,   121,    79,    84,
     332,    79,    70,    76,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    76,
      70,    70,    70,    79,    70,    70,    79,    70,    70,    76,
      70,    70,    76,    70,    70,    70,   359,    70,    70,    70,
      70,   383,    70,    70,    70,    70,    70,    70,    70,    70,
     392,    70,    70,    70,    70,    70,    70,    70,    70,   401,
     402,    70,   404,   405,   406,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,   156,   164,   124,   121,   157,     0,
      76,   407,   121,    76,    79,    79,    76,    76,    76,   422,
      76,    76,    84,    76,   124,    76,    76,   449,    76,    76,
      76,    76,    76,    76,    76,   126,    76,   124,    79,    76,
      79,    79,    76,    76,    76,     0,     1,   459,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    76,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      76,    76,    57,    58,    59,    60,    76,    79,   120,    64,
      65,    66,    67,    68,    69,    70,   120,    79,    79,    79,
     391,   435,   497,    -1,   135,    -1,    -1,    -1,    -1,    -1,
     251
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 4:
{
            if (SetInclude(yyvsp[-1].ch) != 0) {
               YYABORT;
            }
         ;
    break;}
case 7:
{
               if (SetAddToNullPkt() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 14:
{
               if (SetCreateMissingBase() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 16:
{
               if (SetForceINTL() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 34:
{
               if (SetNoLogIgnore() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 40:
{
               if (SetIgnoreBSY() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 41:
{
               if (SetIgnoreAttachPath() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 42:
{
               if (SetSetViaAlways() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 43:
{
               if (SetSkipHiddenFiles() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 44:
{
               if (SetSoftCheckInNodelists() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 47:
{
               if (SetNewVia() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 48:
{
               if (SetUseOwnZone() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 49:
{
	            if (SetUseASO() != 0) {
                  YYABORT;
	            }
	         ;
    break;}
case 50:
{
	            if (SetUseFileBoxes() != 0) {
                  YYABORT;
	            }
	         ;
    break;}
case 51:
{
				   if (SetStripPathInPkt() != 0) {
					   YYABORT;
               }
            ;
    break;}
case 52:
{
               if (SetAgeFromVia() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 64:
{ YYABORT; ;
    break;}
case 65:
{ DetectError = TRUE;
         ;
    break;}
case 66:
{
            avail = 0;
         ;
    break;}
case 67:
{
               if (LoadScriptFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
             ;
    break;}
case 68:
{
               if (SetFileBoxDir(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
             ;
    break;}
case 69:
{ 
                if (SetFileBoxType(yyvsp[0].fbtype) != 0) {
		  YYABORT;
                }
              ;
    break;}
case 70:
{ yyval.fbtype = FILEBOXLONG;
    break;}
case 71:
{ yyval.fbtype = FILEBOXTMLONG ;
    break;}
case 72:
{ yyval.fbtype = FILEBOXTMSHORT ;
    break;}
case 73:
{
                      if (SetTrafficLogTemplate(yyvsp[0].ch) != 0) {
                         YYABORT;
                      }
                   ;
    break;}
case 74:
{
             if (SetSemaphoreName(yyvsp[0].ch, yyvsp[-1].ln) != 0) {
                YYABORT;
             }
          ;
    break;}
case 75:
{ yyval.ch = yyvsp[0].ch; ;
    break;}
case 76:
{ cffa.Clean(); ;
    break;}
case 77:
{ cffa1 = cffa; cffa.Clean(); ;
    break;}
case 78:
{
               if (SetAka(cffa1, cffa) != 0) {
                  YYABORT;
               }
               cffa.Clean();
               cffa1.Clean();
            ;
    break;}
case 79:
{
               if (SetTimeStampFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 80:
{
               if (SetAPktDir(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 81:
{ cffa.Clean(); ;
    break;}
case 82:
{
               if (SetMyAddr(cffa) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 83:
{ SetCheckPoints(yyvsp[0].pmode); ;
    break;}
case 84:
{ yyval.pmode = CHECKPNT_NEVER; ;
    break;}
case 85:
{ yyval.pmode = CHECKPNT_HARD; ;
    break;}
case 86:
{ yyval.pmode = CHECKPNT_SOFT; ;
    break;}
case 87:
{ SetKillRoutedMessages(yyvsp[0].kmode); ;
    break;}
case 88:
{ yyval.kmode = KILL_ALWAYS; ;
    break;}
case 89:
{ yyval.kmode = KILL_NEVER; ;
    break;}
case 90:
{ yyval.kmode = KILL_FLAG; ;
    break;}
case 91:
{
               if (SetSysopName(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 92:
{
               if (SetTearline(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 93:
{
               if (SetLogFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 94:
{
               if (SetLogLevel(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 95:
{
               if (SetOrigin(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 96:
{
               if (SetNodelist(yyvsp[-1].ch,yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 97:
{ yyval.ln = -3; ;
    break;}
case 98:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 99:
{
               if (SetNodelistPath(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 100:
{
               if (SetIndexFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 101:
{
               if (SetLoopStr(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 102:
{
               if (SetMaxAttach(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 103:
{
               if (SetMaxNodelistAge(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 104:
{
               if (SetOutbound(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 105:
{
               if (SetTempMail(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 106:
{
               if (SetTrafficLog(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 107:
{
               if (SetFileInbound(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 108:
{
               if (SetMaxAge(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 109:
{
               if (strlen(yyvsp[0].ch) > 8){
                  yyerror("Password too long. Max password length is a 8 characters.");
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 110:
{
               if (SetPasswd(cffa, yyvsp[-2].ch) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 111:
{ 
                if (SetBadMode(yyvsp[0].bmode,FileName) != 0) {
                  YYABORT;
                }
                FileName = NULL;
              ;
    break;}
case 112:
{ yyval.bmode = SKIP; FileName = NULL;;
    break;}
case 113:
{ yyval.bmode = EXIT; FileName = NULL;;
    break;}
case 114:
{ yyval.bmode = REMOVE; FileName = NULL;;
    break;}
case 115:
{ yyval.bmode = MOVE; FileName = yyvsp[0].ch;;
    break;}
case 116:
{ 
                if (SetBadPktMode(yyvsp[0].bpmode,BPktDir) != 0) {
                  YYABORT;
                }
		BPktDir = NULL;
              ;
    break;}
case 117:
{ yyval.bpmode = SKIP; BPktDir = NULL;;
    break;}
case 118:
{ yyval.bpmode = EXIT; BPktDir = NULL;;
    break;}
case 119:
{ yyval.bpmode = REMOVE; BPktDir = NULL;;
    break;}
case 120:
{ yyval.bpmode = MOVE; BPktDir = yyvsp[0].ch;;
    break;}
case 121:
{ 
                if (SetUTC(yyvsp[0].ln) != 0) {
                  YYABORT;
                }
              ;
    break;}
case 122:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 123:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 124:
{ yyval.ln = -yyvsp[0].ln; ;
    break;}
case 125:
{ 
              wsd = new ScanDir(); 
              CheckMem((char *)wsd); 
              renumberf = FALSE;
              unpackf = FALSE;
              freshf = FALSE;
              arf = FALSE;
              brf = FALSE;
              _TTimes = &wsd->_Times;
              mbase = NULL;
              PrevMask = 0;
              ScriptBefore = NULL;
              ScriptAfter = NULL;
              FileName = NULL;
           ;
    break;}
case 126:
{
              wsd->SetBase(mbase);
              wsd->_Renumber = renumberf;
              wsd->_Unpack = unpackf;
              wsd->_Fresh = freshf;
              wsd->_FlagFile = FileName;
              wsd->_ScriptBefore = ScriptBefore;
              wsd->_ScriptAfter = ScriptAfter;
              ScanDirs.AddToEnd(wsd);
              if (brf) BeforeRoute = wsd;
              if (arf) AfterRoute = wsd;
           ;
    break;}
case 128:
{
             mbase = MakeBase(yyvsp[0].ch);
             if (mbase == NULL) {
                YYABORT;
             }
             if (!mbase->Set(yyvsp[0].ch,BASE_IN)) {
                delete mbase;
                mbase = NULL;
                yyerror("Unable to open message base.");
                YYABORT;
             }
             if (!mbase->CheckIn()) {
                delete mbase;
                YYABORT;
             }
          ;
    break;}
case 130:
{ brf = TRUE; ;
    break;}
case 131:
{ arf = TRUE; ;
    break;}
case 134:
{
                  if (renumberf == TRUE) {
                     yyerror("Renumber for this base already set.");
                     YYABORT;
                  } else {
                    renumberf = TRUE;
                  }
               ;
    break;}
case 135:
{
                  if (ScriptWordExists(yyvsp[0].ch) == FALSE) {
                     yyerror("Script function not found.");
                     YYABORT;
                  } 
                  ScriptBefore = strdup(yyvsp[0].ch);
               ;
    break;}
case 136:
{
                  if (ScriptWordExists(yyvsp[0].ch) == FALSE) {
                     yyerror("Script function not found.");
                     YYABORT;
                  }
                  ScriptAfter = strdup(yyvsp[0].ch);
               ;
    break;}
case 137:
{
                  if (freshf == TRUE) {
                     yyerror("Fresh scripts for this base already set.");
                     YYABORT;
                  } else {
                     freshf = TRUE;
                  }
               ;
    break;}
case 138:
{
                  if (unpackf == TRUE) {
                     yyerror("Unpack for this base already set.");
                     YYABORT;
                  } else {
                     unpackf = TRUE;
                  }
                  if (Outbound == NULL) {
                     yyerror("Outbound directory not specified.");
                     YYABORT;
                  }
               ;
    break;}
case 139:
{
                  if (TimeStampFile == NULL) {
                     yyerror("You can't set scanning time without Timestamp File.");
                     YYABORT;
                  }

               ;
    break;}
case 140:
{
                  tt = new tTimes;
                  tt->_STime = TimeOfBeginOfDay(-1);
                  tt->_ETime = 0;
               ;
    break;}
case 141:
{
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                  }
               ;
    break;}
case 142:
{
                  tt = new tTimes;
                  tt->_STime = TimeOfBeginOfDay(0);
                  tt->_ETime = 0;
               ;
    break;}
case 143:
{
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                  }
               ;
    break;}
case 145:
{ 
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                     tt = new tTimes;
                  }
               ;
    break;}
case 146:
{ 
                  tt->_STime = yyvsp[0].t + TimeOfBeginOfDay(-1); 
               ;
    break;}
case 147:
{ 
                  tt->_STime = yyvsp[-2].t + TimeOfBeginOfDay(-1); 
                  tt->_ETime = yyvsp[0].t + TimeOfBeginOfDay(-1) + 59; 
               ;
    break;}
case 148:
{
                  time_t i_time;
                  time_t b_time;
                  if (yyvsp[0].t == (time_t) 0) {
                     yyerror("Time of pereodical event should be between 00:01 and 23:59");
                     YYABORT;
                  }
                  tt->_STime = TimeOfBeginOfDay(-1);
                  b_time = tt->_STime; 
                  do {
                     i_time = tt->_STime; 
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                     tt = new tTimes;
                     tt->_ETime = 0;
                     tt->_STime = i_time + yyvsp[0].t;
                  } while (tt->_STime < (b_time + (23*60*60)+(59*60)+60));
                  tt->_STime = 0;
            ;
    break;}
case 151:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 23) {
                    yyerror("Hour should be between 00 and 23");
                    YYABORT;
                 } else {
                    yyval.t = (time_t) (yyvsp[0].ln * 60);
                 }
              ;
    break;}
case 152:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 59 || yyvsp[-2].t == (time_t) -1) {
                    yyval.t = (time_t)-1;
                    yyerror("Minutes should be between 00 and 59");
                    YYABORT;
                 } else {
                    yyval.t = yyvsp[-2].t + (time_t) yyvsp[0].ln;
                    yyval.t *= 60;
                 }
              ;
    break;}
case 154:
{ 
                  CheckETTime();
                  _TTimes->AddToEnd(tt);
                  tt = new tTimes;
               ;
    break;}
case 155:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 6) {
                    yyerror("Day of week should be between 0 and 6");
                    YYABORT;
                 } else {
                    tt->_STime = TimeOfBeginOfDay(yyvsp[0].ln); 
                 }
              ;
    break;}
case 156:
{ 
                 if (yyvsp[-2].ln < 0 || yyvsp[-2].ln > 6 || yyvsp[0].ln < 0 || yyvsp[0].ln > 6) {
                    yyerror("Day of week should be between 0 and 6");
                    YYABORT;
                 } else {
                    tt->_STime = TimeOfBeginOfDay(yyvsp[-2].ln); 
                    tt->_ETime = TimeOfBeginOfDay(yyvsp[0].ln) + (23*60*60)+(59*60)+59; 
                 }
              ;
    break;}
case 157:
{ FileName = NULL; ;
    break;}
case 158:
{ FileName = strdup(yyvsp[0].ch); ;
    break;}
case 159:
{ MaskMode = 0; ;
    break;}
case 160:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 161:
{ MaskMode = 0; ;
    break;}
case 162:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 163:
{ MaskMode = 0; ;
    break;}
case 164:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 165:
{ 
               msk = new NormalMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 166:
{
               ((NormalMask *)msk)->_FromName = strdup(yyvsp[0].ch);
               cffa.Clean();
            ;
    break;}
case 167:
{
               ((NormalMask *)msk)->_FromAddr = cffa;
               if (MaskMode == 0) {
                  rc = ((NormalMask *)msk)->_FromAddr.MaskValid(); 
               } else {
                  rc = ((NormalMask *)msk)->_FromAddr.ActValid(); 
               }
               if (!rc) {
                  yyerror("Invalid 'From' Address.");
                  YYABORT;
               }
            ;
    break;}
case 168:
{
               ((NormalMask *)msk)->_ToName = strdup(yyvsp[0].ch);
               cffa.Clean();
            ;
    break;}
case 169:
{
               ((NormalMask *)msk)->_ToAddr = cffa;
               if (MaskMode == 0) {
                  rc = ((NormalMask *)msk)->_ToAddr.MaskValid(); 
               } else {
                  rc = ((NormalMask *)msk)->_ToAddr.ActValid(); 
               }
               if (!rc) {
                  yyerror("Invalid 'To' Address.");
                  YYABORT;
               }
               if ((((NormalMask *)msk)->_ToAddr.Zone() & (FA_LSTMASK|FA_HOLDMASK|FA_DOWNMASK|FA_PVTMASK|FA_HUBMASK)) && (!Ndl.Enabled())) {
                  yyerror("You can't use '#','H','D','U' or 'P' mask without nodelist.");
                  YYABORT;
               }
               if ((((NormalMask *)msk)->_ToAddr.Point() & FA_SUBMASK) && (!Ndl.Enabled())) {
                  yyerror("You can't use '&' mask without nodelist.");
                  YYABORT;
               }
            ;
    break;}
case 170:
{ 
               ((NormalMask *)msk)->_Subject = strdup(yyvsp[0].ch);
               NoTokensF = TRUE; 
            ;
    break;}
case 171:
{ 
               NoTokensF = FALSE; 
            ;
    break;}
case 173:
{ yyval.ch = "$"; ;
    break;}
case 174:
{ yyval.ch = "*"; ;
    break;}
case 175:
{ yyval.ch = "%"; ;
    break;}
case 177:
{ yyval.ch = "*"; ;
    break;}
case 178:
{
               if (yyvsp[0].ln > 65535) {
                  yyerror("Parameter shoul be less that 65535");
                  YYABORT;
               }
               yyval.ln = yyvsp[-1].ln | yyvsp[0].ln;
            ;
    break;}
case 179:
{ yyval.ln = -1; ;
    break;}
case 180:
{ yyval.ln = 0; ;
    break;}
case 181:
{ yyval.ln = 0x08000000; ;
    break;}
case 183:
{ FlagMode = 1; ;
    break;}
case 188:
{ FlagMode = 1; ;
    break;}
case 190:
{ FlagMode = 2; ;
    break;}
case 192:
{ ((NormalMask *)msk)->fFileAttach = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 193:
{ /* CheckMaxAttach size*/
               if (CheckMaskMode("A") != 0) {
                  YYABORT;
               }
               if (((NormalMask *)msk)->sd->_MaxAttachSize == 0 && MaxAttachSize == 0) {
                  yyerror("Not one (global or local) MaxAttachSize is not defined.");
                  YYABORT;
               }
               ((NormalMask *)msk)->fMaxAttach = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 194:
{ ((NormalMask *)msk)->fARQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 195:
{ ((NormalMask *)msk)->fCrash = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 196:
{ ((NormalMask *)msk)->fDIR = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 197:
{ /* Empty message */
               if (CheckMaskMode("e") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fEmpty = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 198:
{ /* Check echomail */
               if (CheckMaskMode("E") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fEchomail = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 199:
{ ((NormalMask *)msk)->fFileRequest = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 200:
{ /* Check age */
               if (CheckMaskMode("g") != 0) {
                  YYABORT;
               }
               if (((NormalMask *)msk)->sd->_MaxAge == 0 && MaxAge == 0) {
                  yyerror("Not one (global or local) MaxAge is not defined.");
                  YYABORT;
               }
               ((NormalMask *)msk)->fMaxAge = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 201:
{ ((NormalMask *)msk)->fHold = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 202:
{ ((NormalMask *)msk)->fTransit = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 203:
{ ((NormalMask *)msk)->fKFS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 204:
{ ((NormalMask *)msk)->fKillSend = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 205:
{ ((NormalMask *)msk)->fLocal = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 206:
{ ((NormalMask *)msk)->fLok = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 207:
{ ((NormalMask *)msk)->fIMM = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 208:
{ ((NormalMask *)msk)->fCFM = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 209:
{ ((NormalMask *)msk)->fOrphan = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 210:
{ ((NormalMask *)msk)->fPrivate = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 211:
{ ((NormalMask *)msk)->fRRQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 212:
{ ((NormalMask *)msk)->fReceived = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 213:
{ ((NormalMask *)msk)->fSend = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 214:
{ ((NormalMask *)msk)->fAS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 215:
{ ((NormalMask *)msk)->fTFS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 216:
{ ((NormalMask *)msk)->fFURQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 217:
{ ((NormalMask *)msk)->fScanned = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 218:
{ /* Check existing attach */
               if (CheckMaskMode("x") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fAttExists = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 219:
{ ((NormalMask *)msk)->fIRR = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 220:
{
               if (CheckMaskMode("loop flag") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fLoop = (FlagMode == 2) ? 2 : 1;
               if (((NormalMask *)msk)->Loops != (unsigned int)-1) {
                  yyerror("Only one loop count should be in mask.");
                  YYABORT;
               }
               ((NormalMask *)msk)->Loops = yyvsp[0].ln;
            ;
    break;}
case 221:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 222:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 223:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 224:
{ 
               msk = new KludgeMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 225:
{
               ((KludgeMask *)msk)-> _KludgeName = strdup(yyvsp[-2].ch);
               ((KludgeMask *)msk)-> _KludgeBody = strdup(yyvsp[-1].ch);
               ((KludgeMask *)msk)-> _Times = yyvsp[0].ln;
            ;
    break;}
case 226:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 227:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 228:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 229:
{ 
               msk = new BodyMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 230:
{
               ((BodyMask *)msk)-> _Body = strdup(yyvsp[-2].ch);
               ((BodyMask *)msk)-> _Lines = yyvsp[-1].ln;
               ((BodyMask *)msk)-> _Bytes = yyvsp[0].ln;
            ;
    break;}
case 231:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(ScriptMask *)msk);
            ;
    break;}
case 232:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(ScriptMask *)msk);
            ;
    break;}
case 233:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(ScriptMask *)msk);
            ;
    break;}
case 234:
{ 
               msk = new ScriptMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 235:
{
               ((ScriptMask *)msk)->_ScriptName = strdup(yyvsp[0].ch);
               if (ScriptWordExists(yyvsp[0].ch) != TRUE) {
                  yyerror("Subroutine not found in scripts.");
                  YYABORT;
               }
            ;
    break;}
case 236:
{
          if (PrevMask == 0) {
             yyerror("Action without Mask.");
             YYABORT;
          }
          wsd = ScanDirs.GetLast();
          PrevMask = 1;
          act = new Action();
          act->sd = wsd;
          act->Before = BeforeRoute;
          act->After = AfterRoute;
         _TTimes = &act->_Times;       
       ;
    break;}
case 237:
{
          LastDo->AddAction(*act);
       ;
    break;}
case 242:
{ act->_Act = ACT_DELETE; ;
    break;}
case 246:
{ act->_Act = ACT_IGNORE; ;
    break;}
case 258:
{ act->_Act = ACT_DELETEATTACH; ;
    break;}
case 269:
{
            act->_Act = ACT_ADDNOTE;
            act->_Tpl = new Template();
            if (!act->_Tpl->Set(yyvsp[0].ch)) {
               yyerror("Template file is not accesible.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               YYABORT;
            }
            act->_Tpl->sd = ScanDirs.GetLast();
         ;
    break;}
case 270:
{
            act->_Act = ACT_MOVE;
            act->_Base = MakeBase(yyvsp[0].ch);
            if (act->_Base == NULL) {
               YYABORT;
            }
            if (!act->_Base->Set(yyvsp[0].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
         ;
    break;}
case 271:
{
            act->_Act = ACT_COPY;
            act->_Base = MakeBase(yyvsp[0].ch);
            if (act->_Base == NULL) {
               YYABORT;
            }
            if (!act->_Base->Set(yyvsp[0].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
         ;
    break;}
case 272:
{
              MaskMode = 1;
              act->_Act = ACT_REWRITE;
           ;
    break;}
case 273:
{
              act->_Mask = msk;
           ;
    break;}
case 274:
{ 
            act->_Act = ACT_DISPLAY; 
            act->_TplName = strdup(yyvsp[0].ch);
         ;
    break;}
case 275:
{
            act->_Act = ACT_SCRIPT;
            if (ScriptWordExists(yyvsp[0].ch) == FALSE) {
               yyerror("Script function not found.");
               YYABORT;
            } 
            act->_TplName = strdup(yyvsp[0].ch);
         ;
    break;}
case 276:
{
            act->_Act = ACT_FLAG; 
            act->_OutDir = strdup(yyvsp[0].ch);
         ;
    break;}
case 277:
{ yyval.ch = yyvsp[0].ch; ;
    break;}
case 278:
{
            act->_Act = ACT_DELFILE;
            act->_OutDir = strdup(yyvsp[0].ch);
         ;
    break;}
case 279:
{
            MaskMode = 1;
            act->_Act = ACT_NEWMSG;
         ;
    break;}
case 280:
{
            act->_Tpl = new Template();
            if (!act->_Tpl->Set(yyvsp[-2].ch)) {
               yyerror("Template file is not accesible.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               YYABORT;
            }
            act->_Tpl->sd =  ScanDirs.GetLast();
            act->_Base = MakeBase(yyvsp[-1].ch);
            if (act->_Base == NULL || !act->_Base->Set(yyvsp[-1].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
            act->_Mask = msk;

         ;
    break;}
case 281:
{
              act->_Act = ACT_WRITEFILE;
              act->_Tpl = new Template();
              if (!act->_Tpl->Set(yyvsp[-1].ch)) {
                 yyerror("Template file is not accesible.");
                 delete act->_Tpl;
                 act->_Tpl = NULL;
                 YYABORT;
              }
              act->_Tpl->sd =  ScanDirs.GetLast();
              act->_OutDir = strdup(yyvsp[0].ch);
           ;
    break;}
case 282:
{
                   act->_Act = ACT_ADDFILE;
                   act->_Tpl = new Template();
                   if (!act->_Tpl->Set(yyvsp[-1].ch)) {
                      yyerror("Template file is not accesible.");
                      delete act->_Tpl;
                      act->_Tpl = NULL;
                      YYABORT;
                   }
                   act->_Tpl->sd =  ScanDirs.GetLast();
                   act->_OutDir = strdup(yyvsp[0].ch);
              ;
    break;}
case 283:
{
           act->_Act = ACT_CALL;
           act->_Tpl = new Template();
           if (!act->_Tpl->Set(yyvsp[-2].ch)) {
              yyerror("Template file is not accesible.");
              delete act->_Tpl;
              act->_Tpl = NULL;
              YYABORT;
           }
           act->_Tpl->sd =  ScanDirs.GetLast();
           act->_OutDir = strdup(yyvsp[-1].ch);
           act->_TplName = strdup(yyvsp[0].ch);
      ;
    break;}
case 284:
{
           act->_Act = ACT_CALL;
           act->_TplName = strdup(yyvsp[0].ch);
      ;
    break;}
case 285:
{ cffa.Clean(); ;
    break;}
case 286:
{
          act->_Act = ACT_ROUTE;
          if (act->sd == act->Before|| act->sd == act->After) {
             yyerror("You can not use the Action Route in 'ScanDir: @AfterRoute|@BeforeRoute'");
             YYABORT;
          }
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
          if (act->_f.Point() & FA_NOTDEF) {
             act->_f.Point(0);
          }
          if (!act->_f.RouValid()) {
             yyerror("Invalid routing address.");
             YYABORT;
          }
       ;
    break;}
case 287:
{ cffa.Clean(); ;
    break;}
case 288:
{
          act->_Act = ACT_ROUTEFBOX;
	  if (FileBoxDir == NULL)
	  {
	   yyerror("You must define FileBoxDir before using Action: RouteFilebox.");
	   YYABORT;
	  }
          if (act->sd == act->Before|| act->sd == act->After) {
             yyerror("You can not use the Action RouteFilebox in 'ScanDir: @AfterRoute|@BeforeRoute'");
             YYABORT;
          }
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
          if (act->_f.Point() & FA_NOTDEF) {
             act->_f.Point(0);
          }
          if (!act->_f.RouValid()) {
             yyerror("Invalid routing address.");
             YYABORT;
          }
       ;
    break;}
case 289:
{ cffa.Clean(); ;
    break;}
case 290:
{
          act->_Act = ACT_ROUTEHUB;
          if (act->sd == act->Before|| act->sd == act->After) {
             yyerror("You can not use the Action RouteHub in 'ScanDir: @AfterRoute|@BeforeRoute'");
             YYABORT;
          }
          act->_Flav = yyvsp[-1].pktmode;
       ;
    break;}
case 291:
{ cffa.Clean(); ;
    break;}
case 292:
{
          act->_Act = ACT_COPYATTACHFBOX;
	  if (FileBoxDir == NULL)
	  {
	   yyerror("You must define FileBoxDir before using Action: CopyAttachFilebox.");
	   YYABORT;
	  }
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
       ;
    break;}
case 293:
{ cffa.Clean(); ;
    break;}
case 294:
{
          act->_Act = ACT_MOVEATTACHFBOX;
	  if (FileBoxDir == NULL)
	  {
	   yyerror("You must define FileBoxDir before using Action: MoveAttachFilebox.");
	   YYABORT;
	  }
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
       ;
    break;}
case 295:
{ yyval.pktmode = F_HOLD; ;
    break;}
case 296:
{ yyval.pktmode = F_CRASH; ;
    break;}
case 297:
{ yyval.pktmode = F_DIRECT; ;
    break;}
case 298:
{ yyval.pktmode = F_NORMAL; ;
    break;}
case 299:
{ cffa.Clean(); ;
    break;}
case 300:
{
          act->_Act = ACT_POLL;
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
          if (act->_f.Point() & FA_NOTDEF) {
             act->_f.Point(0);
          }
          if (!act->_f.RouValid()) {
             yyerror("Invalid poll address.");
             YYABORT;
          }
       ;
    break;}
case 301:
{
               act->_Act = ACT_CHANGEPATH;
               if (strlen(yyvsp[0].ch) > 72) {
                  yyerror("New path too long");
                  YYABORT;
               }	       
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 302:
{
               act->_Act = ACT_TOLOWERPATH;
            ;
    break;}
case 303:
{
               act->_Act = ACT_TOUPPERPATH;
            ;
    break;}
case 304:
{
               act->_Act = ACT_MOVEATTACH;
               if (!DirExists(yyvsp[0].ch)) {
	         Log.Level(LOGE) << "Target directory '" << yyvsp[0].ch << "' not found." << EOL;
               }
               if (strlen(yyvsp[0].ch) > 72) {
                  yyerror("New path too long");
                  YYABORT;
               }	       
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 305:
{
               act->_Act = ACT_COPYATTACH;
               if (!DirExists(yyvsp[0].ch)) {
	         Log.Level(LOGE) << "Target directory '" << yyvsp[0].ch << "' not found." << EOL;	       
               }
               if (strlen(yyvsp[0].ch) > 72) {
                  yyerror("New path too long");
                  YYABORT;
               }	       
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 306:
{
               act->_Act = ACT_SPLIT;
               if (yyvsp[0].ln < 1 || yyvsp[0].ln > 65535) {
                  yyerror("Parameter 'Lines' should be positive integer between 1 and 65535");
                  YYABORT;
               }
               act->_Lines = yyvsp[0].ln;
            ;
    break;}
case 307:
{
               FILE *fp = NULL;
               char buf[512],*p,*q;
               int in,on,count;
               int line = 0;

                  act->_Act = ACT_RECODE;
                  fp = fopen(yyvsp[0].ch,"r");
                  if (fp == NULL) {
                     yyerror("Unable to open file");
                     YYABORT;
                  }
                  act->_TplName = (char *)malloc(256);
                  CheckMem(act->_TplName);
                  for (count = 0; count < 256; count++) act->_TplName[count] = (char) count;
                  count = 0;	 
                  line = 0;

                  while (fgets((char*)buf,sizeof(buf),fp)) {
                     line++;
                     p = strtok((char*)buf," \t\n#");
                     q = strtok(NULL," \t\n#");
                     if (p != NULL && q != NULL) {
                        in = ctoi((char *)p);
                        if (in > 255) {
                           sprintf(buf, "%s: Error in line %d.", yyvsp[0].ch, line);
                           yyerror(buf);
                           fclose(fp);
                           free(act->_TplName);
                           YYABORT;
                        }
                        on=ctoi((char *)q);
                        if (in != 0 && on != 0) {
                           if (count++ < 256 ) {
                              act->_TplName[in]=on; 
                           } else { 
                              sprintf(buf,"Char map table \"%s\" is big",yyvsp[0].ch); 
                              yyerror(buf);
                              fclose(fp);
                              free(act->_TplName);
                              YYABORT;
                           }
                        }
                     } /* if */
                  } /* While */
                  fclose(fp);
            ;
    break;}
case 309:
{ cffa.Zone(cffa.Zone() | FA_NOTMASK); ;
    break;}
case 312:
{
                  cffa.Zone(FA_ANYMASK);
                  cffa.Net(FA_ANYMASK);
                  cffa.Node(FA_ANYMASK);
                  cffa.Point(FA_ANYMASK);
               ;
    break;}
case 313:
{
                  cffa.Zone(FA_LSTMASK);
                  cffa.Net(FA_LSTMASK);
                  cffa.Node(FA_LSTMASK);
                  cffa.Point(FA_LSTMASK);
               ;
    break;}
case 314:
{
                  cffa.Zone(FA_HOLDMASK);
                  cffa.Net(FA_HOLDMASK);
                  cffa.Node(FA_HOLDMASK);
                  cffa.Point(FA_HOLDMASK);
               ;
    break;}
case 315:
{
                  cffa.Zone(FA_HUBMASK);
                  cffa.Net(FA_HUBMASK);
                  cffa.Node(FA_HUBMASK);
                  cffa.Point(FA_HUBMASK);
               ;
    break;}
case 316:
{
                  cffa.Zone(FA_DOWNMASK);
                  cffa.Net(FA_DOWNMASK);
                  cffa.Node(FA_DOWNMASK);
                  cffa.Point(FA_DOWNMASK);
               ;
    break;}
case 317:
{
                  cffa.Zone(FA_PVTMASK);
                  cffa.Net(FA_PVTMASK);
                  cffa.Node(FA_PVTMASK);
                  cffa.Point(FA_PVTMASK);
               ;
    break;}
case 318:
{
                  cffa.Zone(FA_OURMASK);
                  cffa.Net(FA_OURMASK);
                  cffa.Node(FA_OURMASK);
                  cffa.Point(FA_OURMASK);
               ;
    break;}
case 319:
{
                  cffa.Zone(FA_FROMMASK);
                  cffa.Net(FA_FROMMASK);
                  cffa.Node(FA_FROMMASK);
                  cffa.Point(FA_FROMMASK);
               ;
    break;}
case 320:
{
                  cffa.Zone(FA_TOMASK);
                  cffa.Net(FA_TOMASK);
                  cffa.Node(FA_TOMASK);
                  cffa.Point(FA_TOMASK);
               ;
    break;}
case 321:
{
                  if (yyvsp[0].ln != 0) {
                     yyerror("parse error");
                     YYABORT;
                  }
                  cffa.Zone(FA_TOMASK);
                  cffa.Net(FA_TOMASK);
                  cffa.Node(FA_TOMASK);
                  cffa.Point(0);
               ;
    break;}
case 323:
{ cffa.Point(yyvsp[0].ln); ;
    break;}
case 324:
{ cffa.Point(FA_SUBMASK); ;
    break;}
case 325:
{ 
               cffa.Zone(yyvsp[-4].ln); 
               cffa.Net(yyvsp[-2].ln); 
               cffa.Node(yyvsp[0].ln); 
               cffa.Point(0); 
            ;
    break;}
case 326:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 327:
{ yyval.ln = FA_ANYMASK; ;
    break;}
}



  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



